/*
** $Log:   C:/shell/vcs/cat.c_v  $
**
**   Rev 3.5   01 Oct 1986 13:23:48   kent
**Put all globals into shell.h
**
**   Rev 3.4   01 Oct 1986  9:24:18   kent
**Initial revision.
*/
#include "shell.h"
FILE *fd1,*fd2;

static int (*oldcatsig)();
static jmp_buf catenv;
void catintr()
{
	signal(SIGINT,SIG_IGN);			/* ignore signals */
	fclose(fd1);
	fclose(fd2);
	signal(SIGINT,oldcatsig);			/* restore shell interrupt */
	longjmp(catenv,-1);
}

int cat(argc,argv)
	char *argv[];
{
	char *intmsg = "Interrupt received\r\n";

	FILE *fdopen(), *fopen();
	if (-1==setjmp(catenv))
	{
		write(2,intmsg,strlen(intmsg));
		return -1;
	}
	oldcatsig = signal(SIGINT,catintr);	/* trap interrupts from keyboard */
	/* get standard output opened for business */
	if (NULL == (fd2 = fdopen(1,"w")))
	{
		perror("cat : Can't open stdout");
	}

	/* handle pipes */
	if (argc == 1)
	{
		if (NULL == (fd1 = fdopen(0,FTOREAD)))
		{
			perror("cat : Can't open stdin");
		}
		_cat();
		fclose(fd1);fclose(fd2);
	}
	/* handle specified files */
	else
	{
		while(--argc)
		{
			if (NULL == (fd1 = fopen(*(++argv),FTOREAD)))
			{
				fprintf(stderr,"can't open %s\n",*argv);
				continue;
			}
			_cat();
			fclose(fd1);
		}
	}
	fclose(fd2);
	signal(SIGINT,oldcatsig);				/* restore old int catcher		*/
	return 0;
}

_cat()
{
	char buffer[512];
	int in = fileno(fd1), out = fileno(fd2),actual;
	while (0 != (actual = read(in,buffer,512)) && actual != -1)
		write(out,buffer,actual);
}

