/*
** $Log:   C:/shell/vcs/doprompt.c_v  $
**
**   Rev 3.5   01 Oct 1986 13:25:48   kent
**Put all globals into shell.h
**
**   Rev 3.4   01 Oct 1986  9:24:50   kent
**Initial revision.
*/
#include "shell.h"

void do_prompt(c)
	hist_env *c;
{
	char *promptstring;
	extern char *strchr();
	char drive;
	extern void prtime(),prdate();
	if (NULL == (promptstring = get_env("PROMPT")))
	{
		fprintf(stderr,"%d%% ",c->j);
		return;
	}
	while (*promptstring)
	{
		if (*promptstring == '$')
		{
			++promptstring;
			switch(tolower(*promptstring))
			{
			case 't':
				prtime();
				break;
			case '$':
				putc('$',stderr);
				break;
			case 'd':
				prdate();
				break;
			case 'v':
				fputs(version,stderr);
				break;
			case 'p':
				fprintf(stderr,"%s",abspath("."));
				break;
			case 'n':
				drive = bdos(0x19,0,0);
				putc(drive+'A',stderr);
				break;
			case '!':
				fprintf(stderr,"%d",c->j);
				break;
			case 'g':
				putc('>',stderr);
				break;
			case 'l':
				putc('<',stderr);
				break;
			case 'b':
				putc('|',stderr);
				break;
			case 'q':
				putc('=',stderr);
				break;
			case 'h':
				putc('\b',stderr);
				break;
			case 'e':
				putc('\033',stderr);
				break;
			case 's':
				putc(' ',stderr);
				break;
			case '_':
				putc('\n',stderr);
			}
			++promptstring;
		}
		else
			putc(*promptstring++,stderr);
	}
	return;
}
#ifdef AZTEC86
struct time {
	int sec;
	int min;
	int hours;
	int day;
	int month;
	int year;
	int dayofweek;
	int dayofyear;
	int dstflag;
	int hunsec;
} current_time;
#endif
char *days[] = {
	"Sun",
	"Mon",
	"Tue",
	"Wed",
	"Thu",
	"Fri",
	"Sat"
};

#ifdef MSC
#include <time.h>
#endif
void prtime()
{
#ifdef AZTEC86
	dostime(&current_time);
	fprintf(stderr,"%2d:%02d:%02d.%02d",
			current_time.hours,
			current_time.min,
			current_time.sec,
			current_time.hunsec );
#endif
#ifdef MSC
struct tm *newtime;
time_t long_time;
	time(&long_time);
	newtime=localtime(&long_time);
	fprintf(stderr,"%2d:%02d:%02d.%02d",
		newtime->tm_hour, newtime->tm_min, newtime->tm_sec,
		0);
#endif
}

void prdate()
{
#ifdef AZTEC86
	dostime(&current_time);
	fprintf(stderr,"%s %2d-%02d-19%02d",
			days[current_time.dayofweek],
			current_time.month+1,
			current_time.day,
			current_time.year);
#endif
#ifdef MSC
struct tm *newtime;
time_t long_time;
	time(&long_time);
	newtime=localtime(&long_time);
	fprintf(stderr,"%s %2d-%02d-19%02d",
			days[newtime->tm_wday],
			newtime->tm_mon+1,
			newtime->tm_mday,
			newtime->tm_year);
#endif
}
