/*
** $Log:   C:/shell/vcs/env.c_v  $
**
**   Rev 3.6   02 Oct 1986 13:11:54   kent
**lint pass over everything
**
**   Rev 3.5   01 Oct 1986 13:26:28   kent
**Put all globals into shell.h
**
**   Rev 3.4   01 Oct 1986  9:24:26   kent
**Initial revision.
*/

#include "shell.h"
#ifdef MEMDEBUG
int indent = 0;
void *dmalloc(a,b,x)
	char *a;
	int b;
	unsigned x;
{
	register void *y,*malloc();
	register int i;
	for (i = 0; i < indent; i++)
		putc(' ',stderr);
	y = malloc(x);
	fprintf(stderr,"m %s %d: %x size %d\n",a,b,y,x);
	indent++;
	return y;
}

void dfree(a,b,x)
	char *a;
	int b;
	void *x;
{
	register int i;
	for (i = 0; i < indent; i++)
		putc(' ',stderr);
	fprintf(stderr,"f : %s %d %x\n",a,b,x);
	indent = (indent == 0 ? 0 : indent - 1) ;
	if (-1 == free(x))
	{
		fprintf(stderr,"Bad return from free!!\n");
		my_exit(-1);
	}
}
#endif

#define ENVSIZE 1024
#ifdef AZTEC86
extern unsigned int _PSP;
#endif

#ifdef MSC
extern unsigned int _psp;
#endif

char *str_upper();
static char env_init = 0;
static char *environment;
char envbuf[ENVSIZE+16];
static char *next_env;

/* implement aliasing */
int alias(argc,argv)
char *argv[];
{
	int rval;
	char *string,*save; 
	if (argc == 1)
	{
		show_env(1);	/* show aliases */
		return 0;
	}
	string = MustMalloc((unsigned)strlen(argv[1])+2);
	sprintf(string,"`%s",argv[1]);
	save = argv[1];
	argv[1] = string;
	rval = set(argc,argv);
	argv[1] = save;
	Free(string);
	return rval;
}

int unalias(argc,argv)
	char *argv[];
{
	int rval;
	char *string,*save; 
	char *strchr();
	if ((argc == 1) || (argc != 2))
	{
		fprintf(stderr,"unalias : usage unalias name\n");
		return -1;
	}
	if (NULL == (string = Malloc((unsigned)strlen(argv[1])+3)))
	{
		fprintf(stderr,"alias : not enough memory\n");
		return -1;
	}
	sprintf(string,"`%s",argv[1]);
	if (NULL == strchr(string,'='))
		strcat(string,"=");
	save = argv[1];
	argv[1] = string;
	rval = set(argc,argv);
	argv[1] = save;
	Free(string);
	return rval;
}

int set(argc,argv)
char *argv[];
{
	char *strchr();
	char *setbuffer,*addtoline();
	if (env_init == 0)
	{
		init_env();
	}
	if (argc == 1)
	{
		show_env(0);
		return 0;
	}
	setbuffer = NULL;
	if (argc == 2)
		setbuffer = addtoline(setbuffer,argv[1],0);
	/* need to allow for formats such as set var = foo */
	else if (NULL == strchr(argv[1],'=') && argv[2][0] == '=')
	{
		setbuffer = addtoline(setbuffer,argv[1],0);
		setbuffer = addtoline(setbuffer,argv[2],0);
		if (argv[3])
		{
			setbuffer = addtoline(setbuffer,argv[3],0);
		}
	}
	else if (NULL == strchr(argv[1],'=') && NULL == strchr(argv[2],'='))
	{
	/* string of format set var foo */
		setbuffer = addtoline(setbuffer,argv[1],0);
		setbuffer = addtoline(setbuffer,"=",0);
		if (NULL == argv[2])
		{
			fprintf(stderr,"set : not enough args!\n");
			Free(setbuffer);
			return -1;
		}
		setbuffer = addtoline(setbuffer,argv[2],0);
	}
	(void)add_env(setbuffer);
	Free(setbuffer);
	return 0;
}

char *
str_upper(c)
	register char *c;
{
	register char *save = c;
	while(*c)
	{
		*c = toupper(*c);
		c++;
	}
	return save;
}

char *
str_lower(c)
	register char *c;
{
	register char *save = c;
	while(*c)
	{
		*c = tolower(*c);
		c++;
	}
	return save;
}

init_env()
{
#ifdef AZTEC86
	extern unsigned _dsval;	/* current data segment register value */
#endif
#ifdef MSC
	struct SREGS segregs;
	union
	{
		void far *ptr;
		struct { unsigned off,seg; } parts;
	} psp;
	char far *envp; unsigned far *psp_envp;
#endif
	unsigned long fudgefactor;
	register int c;
	unsigned envseg;
	unsigned offset = 0;

	env_init++;
#ifdef AZTEC86
	envseg = peekw(0x2c,_PSP);

	/* convert to absolute long */
	fudgefactor = (unsigned long)_dsval << 4;
#endif
#ifdef MSC
	psp.parts.seg = _psp;	/* get segment */
	psp.parts.off = 0x2c;
	psp_envp = (unsigned far *)psp.ptr;
	envseg = *psp_envp;
	/* convert into a far ptr for use below */
	psp.parts.seg = envseg;	/* put in segment */
	psp.parts.off = 0;
	envp = (char far *)psp.ptr;
	
	segread(&segregs);	/* get segment values */
	fudgefactor = (unsigned long)segregs.ds << 4;
#endif
	/* add in offset of environment space and round up to next paragraph */
	fudgefactor += (unsigned)envbuf + 15;
	fudgefactor &= 0xFFFF0L;

	/*lint -e511 lint doesn't want to know about this!! */

	/* shift back to a 16 bit segment value */
	env_paragraph = (int)((fudgefactor >>4) & 0xFFFF);

	/* subtract out _ds to make short pointer for local use */
#ifdef AZTEC86
	environment = (char *) (fudgefactor - (long)(_dsval << 4));
#endif
#ifdef MSC
	environment = (char *) (fudgefactor - (long)(segregs.ds << 4));
	*psp_envp = env_paragraph;	/* poke new environment into psp */
#endif

	/*lint +e511 lint doesn't want to know about this!! */

	next_env = environment;
#ifdef AZTEC86
	/* copy environment strings */
	while (c = peekb(offset,envseg))
	{
		while (c = peekb(offset++,envseg))
		{
			/* change backslashes to forward slashes */
			*next_env++ = (c == '\\' ? '/' : c);
		}
		*next_env++ = '\0';
	}
#endif
#ifdef MSC
	/* copy environment strings */
	while (c = *envp)
	{
		while (c = *envp++)
		{
			/* change backslashes to forward slashes */
			*next_env++ = (c == '\\' ? '/' : c);
		}
		*next_env++ = '\0';
	}
#endif
	*next_env = '\0';	/* terminate environment */
}

show_env(alias)
{
	register char *env;
	char c;register int isshow;
	for (env = environment;*env;)
	{
		isshow = (alias ? *env == '`' : *env != '`');
		while (c = *env++)
			if (isshow && c != '`')
				write(1,&c,1);
		if (isshow)
			crlf();
	}
}

static char *enverr2 = "Improper environment string format!!\r\n";

char *get_env(string)
	char *string;
{
	char local[33];
	register char *env; char *strchr();
	char *envstring,*strchr();

	strncpy(local,string,32);

	for (env = environment;*env;)
	{
		/* bug fix - reversed local and env in following statement */
		if (0 == strncmp(local,env,strlen(local)) &&
		    '=' == env[strlen(local)] ) 
		{
			/* a match */
			if (NULL == (envstring = strchr(env,'=')))
			{
				write(2,enverr2,strlen(enverr2));
				return NULL;
			}
			/* string desired starts one byte after the equals sign */
			++envstring; return envstring;
		}
		/* &env[strlen(env)] is the terminating NULL of the current string,
		 * so one past that should be start of next string
		 */
		env = &env[strlen(env)+1];
	}
	return NULL;
}

int add_env(string)
	char *string;

{
	char *new, *strchr();
	static char env_copy[ENVSIZE];
	char *old = environment;
	char *name_end,*new_name_end;
	int added = 0;
	int namelen,newnamelen;

	memset(env_copy,0,ENVSIZE);
	new = env_copy;
	while (*old)
	{
		if ( NULL == (name_end = strchr(old,'=')) || 
			NULL == (new_name_end = strchr(string,'=')))
				goto copystring;
#ifdef NOTDEF
		{
			write(2,enverr2,strlen(enverr2));
			return -1;
		}
#endif
		namelen = (int)(name_end - old);
		newnamelen = (int)(new_name_end - string);
		if (0 == (namelen > newnamelen ? strncmp(old,string,namelen) :
					strncmp(old,string,newnamelen))
		   )
		{
			if (new_name_end[1])
			{
				/* if we don't have a string of the form name= */
				/* copy new string instead of old string */
				strcpy(new,string);
			}
			else
			/* if we have a set name= with no string then we want
			   to remove the string from the environment
			 */
				;
			added++;
		}
		else
		{
copystring:
			strcpy(new,old);	/* copy old string to new environment */
		}
		if (strlen(new) > 0)
			new = &new[strlen(new)+1];	/* bump past current string */
		old = &old[strlen(old)+1];
		if ((unsigned)new >= (unsigned)&env_copy[ENVSIZE-1])
		{
			fprintf(stderr,"no more environment space current = %u, top = %u\n",
				new,&env_copy[ENVSIZE-1]);
			return -1;
		}
	}
	if (!added)
	{
		strcpy(new,string);
	}
	new = &new[strlen(new)+1];
	/* clear old environment */
	memset(environment,0,ENVSIZE);
	/* copy the copy back to the environment */
	memcpy(environment,env_copy,ENVSIZE);
	return 0;
}

/* change all forward slashes to backslashes in environment */
void env_change_backslashes()
{
	register char *ep = environment;
	while (*ep)
	{
		while (*ep)
		{
			*ep = (*ep == '/') ? '\\' : *ep;
			ep++;
		}
		ep++;
	}
}
