/*
** $Log:   C:/shell/vcs/misc.c_v  $
**
**   Rev 3.6   02 Oct 1986 13:13:14   kent
**lint pass over everything
**
**   Rev 3.5   01 Oct 1986 13:27:52   kent
**Put all globals into shell.h
**
**   Rev 3.4   01 Oct 1986  9:24:58   kent
**Initial revision.
*/
#include "shell.h"
#ifdef MSC
#define fdup(a,b)	dup2(a,b)
#endif
/* misc.c - contains everything too small to put into its own source file */


crlf()
{
	static char *cr = "\r\n";
	write(1,cr,2);
}

int scr_clear()
{
	return write(2,"\033[2J",4) ? 0 : -1;
}

int drive(argc,argv)
	char *argv[];
{
	char *dir,*getcwd();
	extern int errno;
#ifdef AZTEC86
	extern unsigned int _dsval;
#endif
	struct registers regs;
	if (argc != 1)
		return -1;
	errno = 0;
	regs.ax = 0xe00;
	regs.dx = toupper(**argv) - 'A';
#ifdef AZTEC86
	if (sysint21(&regs,&regs) & 1)
#endif
#ifdef MSC
	sysint21(&regs,&regs);
	if (regs.cflag)
#endif
	{
err_out:
		fprintf(stderr,"%s : invalid drive\n",*argv);
		return -1;
	}
	dir = MustMalloc((unsigned)65);
	regs.ax = 0x4700;
	regs.si = (int)dir;
	regs.dx = (toupper(**argv)-'@') & 0xFF;
#ifdef AZTEC86
	regs.ds = (int)_dsval;
	if ((sysint21(&regs,&regs) & 1))
#endif
#ifdef MSC
	GETSEGS(&regs);
	sysint21(&regs,&regs);
	if (regs.cflag)
#endif
	{
		Free(dir);
		goto err_out;
	}
	free(dir);
	return 0;
}


int echo(argc,argv)
	register char *argv[];
{
	register int i; int nonewline = 0;
	if (argc==2)
	{
		if (0 == strcmp(argv[1],"OFF") ||
		    0 == strcmp(argv[1],"off"))
		{
			verbose = 0;
			return 0;
		}
		else if (0 == strcmp(argv[1],"ON") ||
			     0 == strcmp(argv[1],"on"))
		{
			verbose = 1;
			return 0;
		}

	}
	if (0 == strcmp(argv[1],"-n"))
	{
		nonewline++;
		++argv;
		--argc;
	}
		
	for (i = 1; i < argc;i++)
	{
		write(1,argv[i],strlen(argv[i]));
		if (i < argc-1)
			write(1," ",1);
	}
	if (!nonewline) crlf();
	return 0;
}


int
invalid(argc,argv)
	char *argv[];
{
	register int i;
	static char *invmsg = "sh : bad command : ";
	write(2,invmsg,strlen(invmsg));
	for (i = 0; i < argc;i++)
	{
		write(2,argv[i],strlen(argv[i]));
		write(2," ",1);
	}
	return -1;
}

int touch(argc,argv)
	char *argv[];
{
	while(--argc)
		utime(*(++argv),NULL);
	return 0;
}
#ifdef AZTEC86
int MEMRY;
int SP;
int DS;
int CS;
int mon()
{
extern unsigned int 
_Corg, _Cend, _Dorg, _Dend, _Uorg,_Uend, _mbot, _mtop,
_sbot,_dsval,_csval,_PSP,_STKSIZ,_HEAPSIZ,_STKLOW;
#ifndef _lint
#asm
dataseg segment para public 'data'
	extrn $MEMRY:word
dataseg ends
	mov ax,$MEMRY
	mov MEMRY_,ax
	mov SP_,sp
	mov DS_,ds
	mov CS_,cs
#endasm
#endif
	fprintf(stderr,"Corg : %04x Cend : %04x Dorg : %04x Dend %04x\n",
	&_Corg, &_Cend,&_Dorg, &_Dend);
	fprintf(stderr,"Uorg : %04x Uend : %04x mbot : %04x mtop %04x\n",
	&_Uorg, &_Uend,_mbot, _mtop);
	fprintf(stderr,"sbot : %04x PSP  : %04x STKSIZ : %05d HEAPSIZ : %05d\n",
	_sbot,_PSP,_STKSIZ,_HEAPSIZ);
	fprintf(stderr,"dsval : %04x csval : %04x\n", _dsval,_csval);
	fprintf(stderr,"STKLOW : %04x MEMRY : %04x\n",_STKLOW,MEMRY);
	fprintf(stderr,"CS : %04x DS : %04x SP : %04x\n",CS,DS,SP);
	return 0;
}
#endif

#ifndef NULL
#define NULL ((void *)0)
#endif
static char *errors[] =
{
NULL,
"bad function",
"file not found",
"path not found",
"too many open files",
"access denied",
"invalid handle",
"memory trashed",
"insufficient memory",
"invalid memory block address",
"invalid environment",
"invalid format",
"invalid access code",
"invalid data",
"mysterious internal DOS error",
"invalid drive",
"can't remove current directory",
"not same device",
"no more files",
"unknown error"
};

void print_error(string,code)
	char *string;
{
	write(2,string,strlen(string));
	write(2," : ",3);
	if (code < 0 || code > 18)
		code = 19;
	write(2,errors[code],strlen(errors[code]));
	write(2,"\r\n",2);
}

int inputfile; /* used in expand.c to get input */

int std_save(files)
	int files[3];
{
	register int f;
	/* we need to find a file handle associated with the tty */
	if (-1 ==
		(f = (isatty(0) ? 0 : (isatty(1) ? 1 : (isatty(2) ? 2 : -1)))))
		f = open("con",O_RDWR);	/* this is a punt, and will not work if
								   ctty is in effect */
	else
		f = dup(f);
	files[0] = dup(0);
	files[1] = dup(1);
	files[2] = dup(2);
	inputfile = files[0];
	fdup(f,0);
	fdup(f,1);
	fdup(f,2);
	close(f);
	return 0;
}

void 
std_restore(files)
	int files[3];
{
	fdup(files[0],0);
	fdup(files[1],1);
	fdup(files[2],2);
	close(files[0]);
	close(files[1]);
	close(files[2]);
}

int switchar(argc,argv)
	char **argv;
{
	if (argc == 1)
	{
		fprintf(stderr,"%c\n",get_switch());
		return 0;
	}
	set_switch(*argv[1]);
	return 0;
}


int shell_read(argc,argv)
	int argc;
	char **argv;
{
	int rval; int i;
	char *buf = MustMalloc((unsigned)128),*bufptr; char *ntharg();
	char *sprintbuf = MustMalloc((unsigned)128);
	/* read takes words off of the command line and assigns them to environment
	** strings, one word per argument, except that the last argument consumes
	** all remaining arguments
	*/
	if (0 == getline(0,buf))
	{
		rval = 1;
		goto done;
	}
	i = 0;
	while (--argc)
	{
		++argv;
		if (NULL == (bufptr = ntharg(buf,(unsigned)i)))
			break;
		if (argc > 1)
		{
			sprintf(sprintbuf,"%s=%s",*argv,bufptr);
			(void)add_env(sprintbuf);
		} else
		{
			char pad = 0;
			/* suck up everything else */
			free(sprintbuf); sprintbuf = NULL;
			sprintbuf = addtoline(sprintbuf,*argv,0);
			sprintbuf = addtoline(sprintbuf,"=",0);
			for(;NULL != (bufptr = ntharg(buf,(unsigned)i));i++)
				sprintbuf = addtoline(sprintbuf,bufptr,pad++);
			(void)add_env(sprintbuf);
			break;
		}
		i++;
	}
	rval = 0;
done:
	free(sprintbuf);
	free(buf);
	return rval;
}
