/*
** $Log:   C:/shell/vcs/ntharg.c_v  $
**
**   Rev 3.5   01 Oct 1986 13:30:18   kent
**Put all globals into shell.h
**
**   Rev 3.4   01 Oct 1986  9:24:12   kent
**Initial revision.
*/
#include "shell.h"

char *
ntharg(line,index)
register char *line;
unsigned index;
{
	register unsigned i;
	static char buf[256];
	char *bptr;
	for (i = 0; *line;i++)
	{
		/* find start of arg[i] */
		while(*line && isspace(*line))
		{
			++line;
		}
		if (*line=='\0')
			return NULL;
		/* if this is start of requested arg, return pointer to it */
		if (i == index)
		{
			bptr = buf;
			if ('\'' != *line && '"' != *line)
			{
				while(*line && !isspace(*line))
					*bptr++ = *line++;
				*bptr = '\0';
				return buf;
			}
			else
			{
				char quotechar = *line;
				*bptr++ = *line++;	/* skip the quote */
				while (*line && *line != quotechar)
					if ('\\' == (*bptr++ = *line++))
					{
						if ('\0' == (*bptr++ = *line++))
						{
							--line;
							break;
						}
					}
				if (*line)
				{
					*bptr++ = *line;
					*bptr = '\0';
					return buf;
				}
				else
					return BADQUOTES;
			}
		}
		if (*line != '\'' && *line != '"')
			/* find end of arg[i] */
			while(*line && !isspace(*line))
				++line;
		else
		{
			char quotechar = *line++;
			while (*line && *line != quotechar)
				++line;
			if (*line == quotechar)
				++line;
		}
	}
	return NULL;
}

int lastarg(line)
register char *line;
{
	register unsigned int i;
	for(i = 0;;i++)
		if (NULL == ntharg(line,i))
			return (int)(i - 1);
#ifdef _lint
	return 0;
#endif
}
