#if (sizeof(char *) == 4)
int _STKSIZ = 8192/16;  /* (in paragraphs) (large data model) */
#else
int _STKSIZ = 4096/16;  /* (in paragraphs) */
#endif

int _HEAPSIZ = 4096/16; /* (in paragraphs) */
int _STKLOW = 1;		/* default is stack above heap (small only) */

#if (sizeof(char *) == 4)
int _STKRED = 1024;		/* size of stack RED zone (in bytes) */
#else
int _STKRED = 256;		/* size of stack RED zone (in bytes) */
#endif

/* 
 * NOTE: The RED zone is used for stack saftey checking.  With the stack
 * above the heap, the heap will not be allowed to get within STKRED bytes
 * of the current value of the stack pointer and if limit checking (see the
 * cc +b option) is enabled, the stack pointer isn't allowed any closer than
 * STKRED bytes to the top of the heap.  If the stack is below the heap and
 * limit checking is enabled, the stack pointer isn't allowed any closer than
 * STKRED bytes to Utop.  The minimum stack size is twice the size of the
 * RED zone.  The minimum value for STKRED should be about 256 bytes.  This
 * will allow some margin to issue DOS calls and allow interrupt handlers to
 * execute.  (Some people think that this should be > 1k.)
 */
